{ ENGINE.PAS                                       Copyright (c) Martin Kolecek }
{ Unit Engine.pas je urceny pro DOS, pro Borland Pascal 7.0 realny rezim, nebo  }
{ freepascal. Ma za cil vytvareni jednoduchych 2D her s podporou slozitych zvuku} 
{ pres PC-Speaker na pozadi behu programu, drzeni nekolika klaves na klavesnici }
{ najednou, BMP soubory a grafika podobna na 8mi-bitove NINTENDO. Plati zde     }
{ limit 640KB takze pri pouziti vsech hlavnich funkci enginu vytvorite program  }
{ velky maximalne 90KB (samozrejme se nepocitaji data externich souboru) pak    }
{ dojde k chybe "heap overflow" (naraz na limit 640KB), takze je to vhodne spis }
{ na male projekty jako je ukazkova hra milknuts. Ovsem je treba uvest ze o     }
{ vsechno je uz postarano v enginu od grafiky pres zvuky az po mapu takze se    }
{ muzete soustredit hlavne na hru samotnou. Verze pro freepascal limitem 640KB  }
{ samozrejme netrpi.                                                            }
{                                                                               }
{ Author: Martin Kolecek                                                        }
{ Datum: 01.05.2011                                       http://www.trsek.com  }

{$MODE FPC}
{$Q-}{$R-}{$S-}{$D-}
Unit Engine;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Interface

Var
  Key: array[0..127] of Boolean;

  Buffer: array[1..3] of Word;

 {Graphics}
  Procedure Init320x200;
  Procedure Init80x25;
  Procedure WaitRetrace;

  Procedure InitBuffers;
  Procedure ShutdownBuffers;

  Procedure GetPal(Color:Byte; Var R,G,B:Byte);
  Procedure SetPal(Color:Byte; R,G,B:Byte);

  Procedure LoadGRPage(JmenoSouboru:string;Pozice:LongInt);
  Procedure LoadBmpFile(JmenoSouboru: string; pozice: LongInt; StartColor: Byte);

  Procedure LoadBlok(x1,y1,x2,y2,x3,y3,BufferTo: Word);
  Procedure LoadBlokM(x1,y1,x2,y2,x3,y3,BufferTo: Word);
  Procedure LoadSprite(x1,y1,x2,y2,x3,y3,BufferTo: Word);
  Procedure LoadSpriteM(x1,y1,x2,y2,x3,y3,BufferTo: Word);
  Procedure LoadBitMap(X,Y: Word; BufferTo: Word);
  Procedure LoadBitMapM(X,Y: Word; BufferTo: Word);

  Procedure WritePixel(X:Word;Y,Color:Byte;Buffer:Word);
  Procedure Blok(x1,y1,x2,y2,Color,Buffer:Word);
  Procedure Ramecek(X1,Y1,X2,Y2:Word;Color:Byte;Buffer:Word);
  Procedure WriteBlok(x1,y1,x2,y2,x3,y3,BufferFrom,BufferTo: Word);
  Procedure WriteSprite(x1,y1,x2,y2,x3,y3,BufferFrom,BufferTo: Word);
  Procedure FlipPage(BufferFrom,BufferTo: Word);
  Procedure ClearPage(Buffer:Word);


 {Texter}
  Procedure InitTexter(Barva:Byte);
  Procedure ShutdownTexter;
  Procedure ChangeTexterColor(Barva:Byte);
  Procedure WriteText(X,Y:Word;retezec:string;BufferTo:Word);
  Procedure WriteNumber(x,y:Word;Cislo:Longint;Small:Boolean;BufferTo:Word);


 {Mapa}
  Procedure LoadMapFile(soubor:string; pozice:Longint);
  Procedure SetMapByte(MapOffset:Word;bajt:Byte);
  Function  GetMapByte(MapOffset:Word): Byte;


 {Keyboard}
  Procedure InitKeyboard;
  Procedure ShutdownKeyboard;


 {Timer}
  Procedure InitTimer;
  Procedure ShutdownTimer;

  Procedure Wait(ms: Word);

  Procedure Sound(Hertz: Word);
  Procedure Silence;

  Procedure Stopky_Start;
  Procedure Stopky_Stop;
  Function  Stopky_GetNumber: LongInt;

  Procedure LoadSNDFile(Filename:String;Pozice:LongInt);
  Procedure LoadRAWFile(filename:String;Pozice:LongInt;N:Byte); {do 32KB}

  Procedure PlaySound(Sample:Byte);
  Procedure PlayRaw(Cislo:Byte);
  Procedure StopPlay;

  Function  FPS2s: Boolean;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Implementation

Uses Go32;

Type
  TRGB= Record
          R: Byte;
          G: Byte;
          B: Byte;
        End;

  TBMPHeader = Record
                 Id: Word;
                 Velikost: LongInt;
                 Reserved: LongInt;
                 DataOffset: LongInt;
                 HeaderSize: LongInt;
                 RozsahX: LongInt;
                 RozsahY: LongInt;
                 BitPlanes: Word;
                 BPP: Word;
                 Komprese: LongInt;
                 ImageSize: LongInt;
                 HorizontalRes: LongInt;
                 VerticalRes: LongInt;
                 Colors: LongInt;
                 ImportantColors: LongInt;
               End;

  TBmpRGB = Record
            B: Byte;
            G: Byte;
            R: Byte;
            Reserved: Byte;
          End;

  TBMP = Record
           Header: TBMPHeader;
           Palette: array[0..15] of TBmpRGB;
           DataByte: Byte;
         End;

  TMapa = Record
            MapBuffer: array[0..63999] of Byte;
            MapBufferRLE: array[0..63999] of Byte;
            DelkaRLE: Word;
          End;

  TSample = Record
              Delka: LongInt;
              Pocitadlo: Word;
            End;

  TSampleData = Record
                  Data: array[0..31999] of Byte;
                End;

  TKompress = Record
                DataB: array[0..9999] of Byte;
              End;

Const
  int1c = $1c;
  kbdint = $9;

  MaxRawu = 20;

  znaky: array[0..204] of Byte = (
{A}  126,144,144,144,126,
{B}  254,146,146,146,108,
{C}  124,130,130,130,68,
{D}  254,130,130,130,124,
{E}  254,146,146,146,130,
{F}  254,144,144,144,128,
{G}  124,130,146,146,92,
{H}  254,16,16,16,254,
{I}  130,254,130,0,0,
{J}  4,2,2,2,252,
{K}  254,16,40,68,130,
{L}  254,2,2,2,2,
{M}  254,64,32,64,254,
{N}  254,32,16,8,254,
{O}  124,130,130,130,124,
{P}  254,144,144,144,96,
{Q}  124,130,138,134,126,
{R}  254,144,152,148,98,
{S}  100,146,146,146,76,
{T}  128,128,254,128,128,
{U}  252,2,2,2,252,
{V}  248,4,2,4,248,
{W}  252,2,4,2,252,
{X}  198,40,16,40,198,
{Y}  224,16,14,16,224,
{Z}  134,138,146,162,194,
{+}  16,16,124,16,16,
{-}  16,16,16,16,16,
{x}  40,16,40,
{/}  2,4,8,16,32,64,128,
{:}  0,0,40,0,0,
{.}  2,0,0,0,0,
{,}  6,0,0,0,0,
{=}  40,40,40,40,40,
{?}  64,128,138,144,96,
{%}  4,72,16,36,64,
{!}  250,0,0,0,0,
{(}  56,68,130,0,0,
{)}  130,68,56,0,0,
{>}  130,68,40,16,0,
{<}  16,40,68,130,0);

  SmallZnaky: array[0..131] of Byte = (
{a}  2,21,21,21,14,1,
{b}  127,10,17,17,14,
{c}  14,17,17,17,10,
{d}  14,17,17,10,127,
{e}  14,17,21,21,12,
{f}  5,63,69,64,32,
{g}  57,69,69,62,64,
{h}  127,8,16,16,15,
{i}  1,47,1,
{j}  1,33,190,
{k}  127,4,10,17,
{l}  64,127,1,
{m}  31,8,16,15,16,15,
{n}  31,8,16,16,15,
{o}  14,17,17,17,14,
{p}  65,127,41,68,68,56,
{q}  56,68,68,41,127,65,
{r}  31,8,16,16,8,
{s}  9,21,21,21,18,
{t}  16,126,17,2,
{u}  16,30,1,17,30,1,
{v}  28,2,1,2,28,
{w}  28,2,1,2,1,2,28,
{x}  17,10,4,10,17,
{y}  112,9,9,10,124,
{z}  17,19,21,25,17,
{}  32,80,32 );

  Cifry: array[0..49] of Byte = (
{0} 124,138,146,162,124,
{1} 34,66,254,2,2,
{2} 78,146,146,146,98,
{3} 130,146,146,146,108,
{4} 16,48,80,144,254,
{5} 242,146,146,146,140,
{6} 124,146,146,146,76,
{7} 130,132,136,144,224,
{8} 108,146,146,146,108,
{9} 100,146,146,146,124);

  SmallCifry: array[0..39] of Byte = (
{0} 112,136,136,112,
{1} 40,72,248,8,
{2} 152,168,168,72,
{3} 136,168,168,80,
{4} 32,96,160,248,
{5} 232,168,168,144,
{6} 112,168,168,16,
{7} 128,152,160,192,
{8} 80,168,168,80,
{9} 64,168,168,112);


Var
  {section misc}
  F: File;

  RLEKompressed: array[1..2] of TKompress;
  RLE: array[1..2] of TKompress;
  RLEdelka: Word;

  b: array[0..7] of Byte;

  {section graphics}
  Bmp: TBMP;

  Grafika: array[0..7999] of Byte;
  Barvy4:  array[0..999] of Byte;
  Paleta:  array[0..47] of Byte;
  Barva: array[0..15] of TRGB;
  Buffer2: array[0..1999] of Byte;
  BufferSel: array[1..3] of Word;
  BufferL: array[1..3] of LongInt;
  Buffer0: array[0..31999] of Byte;

  BufferC : array[0..1434] of Byte;
  BufferC1: array[0..349] of Byte;
  BufferC2: array[0..279] of Byte;
  BufferC3: array[0..1055] of Byte;

  CisloStranky: Byte;
  TexterColor: Byte;


  {section map}
  Map: TMapa;


  {section  keyboard}
  oldint9_handler : tseginfo;
  newint9_handler : tseginfo;
  clickproc : pointer;
  Backup1DS : Word; external name '___v2prt0_ds_alias';
  PressedKey: Byte;


  {section timer}
  timerproc: pointer;
  oldint1c : tseginfo;
  newint1c : tseginfo;
  Backup2DS : Word; external name '___v2prt0_ds_alias';

  StopkyTics: LongInt;
  StopkyActive: Boolean;
  stopky: LongInt;

  SoundData: array[0..1999] of Word; {Data zvuku snd}
  ZvukTab: array[0..99] of Word; {Zacatky a Delky zvuku snd}

  PrehravatZvuk: Boolean; {start hrani zvuku}
  CisloZvuku: Byte;       {poradi v tabulce zvuku}
  PosuvZ: Word;           {posun po zvuku}

  delaycounter: Word; {pocitadlo milisekund pro Wait}
  waiting: Boolean;   {jestli je volana procedura Wait}
  player: Byte;       {obecne pocitadlo - setiny vterin}
  fps_helper: Byte;   {pomocna promenna na vypocet FPS}

  vzorek: Byte;
  PrehravanyZvuk: Byte;   {zvuk ktery hraje}
  PocetRawu: Byte;        {pocet rawu v pameti}
  RawHraje: Boolean;      {True=Raw hraje}
  Sample: array[0..MaxRawu] of TSample; {Data Rawu}
  SampleData: array[0..MaxRawu] of TSampleData; {Data Rawu}
  SPBuffer: array[0..31999] of Byte; {prehravaci pamet Rawu}
  OffsetSpeakeru: Word;   {offset do bufferu speakeru 32KB}

{SECTION MISC XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Procedure MovArrayTo2; {RLE => SoundData a ZvukTab}
Var I,A: Word;
Begin
  A:=0;
  For I:=0 to 1999 do
  Begin
    SoundData[I]:=RLE[2].DataB[A];
    SoundData[I]:=(SoundData[I] SHL 8) OR RLE[2].DataB[A+1];
    Inc(A,2);
  End;
  For I:=0 to 99 do
  Begin
    ZvukTab[I]:=RLE[2].DataB[A];
    ZvukTab[I]:=(ZvukTab[I] SHL 8) OR RLE[2].DataB[A+1];
    Inc(A,2);
  End;
End;


Procedure MovArraysTo3;
Var I,A: Word;
Begin
  A:=0;
  For I:=0 to 7999 do Begin Grafika[I]:=RLE[1].DataB[A]; Inc(A); End;
  For I:=0 to 999 do Begin Barvy4[I]:=RLE[1].DataB[A]; Inc(A); End;
  For I:=0 to 47 do Begin Paleta[I]:=RLE[1].DataB[A]; Inc(A); End;
  CisloStranky:=RLE[1].DataB[9048];
End;


Procedure RLEDekompress(H: Byte);
Var
  WritedBA: Byte; {znak A}
  WritedBB: Byte; {je-li komprese tak stejny jako znak A}
  WritedBC: Byte; {pocet kolikrat tam je znak A }
  I,A,posun: Word;
Begin
    I:=0; posun:=0;
    While not (posun=RLEDelka) do
    Begin

      WritedBA:=RLEKompressed[H].DataB[posun]; {nacteme A}
      Inc(posun);
      If posun=RLEDelka then                 {je-li konec zapsat a BREAK}
      Begin
        RLE[H].DataB[I]:=WritedBA;
        Break;
      End;

      WritedBB:=RLEKompressed[H].DataB[posun]; {nacteme B}
      Inc(posun);

      If posun=RLEDelka then               {je-li konec zapsat a BREAK}
      Begin
        RLE[H].DataB[I]:=WritedBA;
        RLE[H].DataB[I+1]:=WritedBB;
        Break;
      End;

      If WritedBA=WritedBB then  {jsou-li dva stejne tzn. nasleduje pocet}
      Begin
        WritedBC:=RLEKompressed[H].DataB[posun]; {muzeme nacist pocet}
        Inc(posun);
        For A:=1 to WritedBC do
        Begin
          RLE[H].DataB[I]:=WritedBA; {zapisujeme WritedBC krat}
          Inc(I);
        End;
      End else {jsou dva ruzne}
      Begin
        RLE[H].DataB[I]:=WritedBA;   {zapisme jeden a navrat nahoru}
        Inc(I);
        Dec(posun);         {posuneme index o jednu nazpet}
      End;

    End; {While End}
End;


Function Bin2Dec(b7,b6,b5,b4,b3,b2,b1,b0: Byte): Byte;
Var I: Byte;
Begin
  I:=0;
  If b7=1 then Inc(I,128);
  If b6=1 then Inc(I,64);
  If b5=1 then Inc(I,32);
  If b4=1 then Inc(I,16);
  If b3=1 then Inc(I,8);
  If b2=1 then Inc(I,4);
  If b1=1 then Inc(I,2);
  If b0=1 then Inc(I,1);
  Bin2Dec:=I;
End;


Procedure Dec2Bin(DCnum:Byte);
Var I: Byte;
Begin
  For I:=0 to 7 do b[I]:=(DCnum AND (1 SHL I)) SHR I;
End;


Procedure GetPal(Color:Byte; Var R,G,B:Byte);
Begin
   OutPortB($3c7,Color);
   R:=InPortB($3c9);
   G:=InPortB($3c9);
   B:=InPortB($3c9);
End;


Procedure SetPal(Color:Byte; R,G,B:Byte);
Begin
   OutPortB($3c8,Color);
   OutPortB($3c9,R);
   OutPortB($3c9,G);
   OutPortB($3c9,B);
End;


Procedure Rozkodovat;
Var Offset32,Offset2,Xa,Ya,X1,Y1,x,y,A,I: Word;
Begin
  {Rozkodovani grafiky 8000B}
  A:=0; I:=0;
  Repeat
    Dec2Bin(Grafika[I]);
    Buffer0[A+0]:=Bin2Dec(0,0,0,0,0,0,b[1],b[0]);
    Buffer0[A+1]:=Bin2Dec(0,0,0,0,0,0,b[3],b[2]);
    Buffer0[A+2]:=Bin2Dec(0,0,0,0,0,0,b[5],b[4]);
    Buffer0[A+3]:=Bin2Dec(0,0,0,0,0,0,b[7],b[6]);
    Inc(A,4);
    Inc(I);
  Until I=8000;
  {Rozkodovani barvy4 2000B}
  A:=0; I:=0;
  Repeat
    Dec2Bin(Barvy4[I]);
    Buffer2[A+0]:=Bin2Dec(0,0,0,0,b[3],b[2],b[1],b[0]);
    Buffer2[A+1]:=Bin2Dec(0,0,0,0,b[7],b[6],b[5],b[4]);
    Inc(A,2);
    Inc(I);
  Until I=1000;
  {Nahravani palety RGB ze souboru}
  A:=0;
  For I:=0 to 15 do
  Begin
    Barva[I].R:=Paleta[A+0];
    Barva[I].G:=Paleta[A+1];
    Barva[I].B:=Paleta[A+2];
    Inc(A,3);
  End;
  {Nastaveni palety RGB - nutny graficky rezim}
  For I:=0 to 15 do SetPal(CisloStranky*16+I,Barva[I].R,Barva[I].G,Barva[I].B);

  {Nastaveni spravnych barev 160x200 po krocich 8x8}
  For Ya:=0 to 24 do
  For Xa:=0 to 19 do
  Begin
    For y:=0 to 7 do
    For x:=0 to 7 do
    Begin
      X1:=Trunc((Xa*8+x)/8);
      Y1:=Trunc((Ya*8+y)/8);
      Offset2:=(Y1*20+X1)*4;
      Offset32:=((Ya*8+y)*160)+(Xa*8+x);
      Case Buffer0[Offset32] of
        0: Begin
             If Buffer2[Offset2+0]>0
             then Buffer0[Offset32]:=Buffer2[Offset2+0]+(CisloStranky*16)
             else Buffer0[Offset32]:=0;
           End;
        1: Begin
             If Buffer2[Offset2+1]>0
             then Buffer0[Offset32]:=Buffer2[Offset2+1]+(CisloStranky*16)
             else Buffer0[Offset32]:=0;
           End;
        2: Begin
             If Buffer2[Offset2+2]>0
             then Buffer0[Offset32]:=Buffer2[Offset2+2]+(CisloStranky*16)
             else Buffer0[Offset32]:=0;
           End;
        3: Begin
             If Buffer2[Offset2+3]>0
             then Buffer0[Offset32]:=Buffer2[Offset2+3]+(CisloStranky*16)
             else Buffer0[Offset32]:=0;
           End;
      End; {Case End}
    End;
  End;
End;


{SECTION GRAPHICS XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Procedure Init320x200; Assembler;
Asm
  Mov AH, 00h
  Mov AL, 13h
  Int 10h
End;


Procedure Init80x25; Assembler;
Asm
  Mov AH, 00h
  Mov AL, 03h
  Int 10h
End;


Procedure WaitRetrace; Assembler;
Asm
    Mov dx,3DAh
@l1:
    In al,dx
    And al,08h
    Jnz @l1
@l2:
    In al,dx
    And al,08h
    Jz  @l2
End;


Procedure InitBuffers;
Var I,x: Word;
Begin
  For I:=1 to 3 do
  Begin
    BufferL[I]:=Global_DOS_Alloc(64000);
    BufferSel[I]:=Word(BufferL[I]);
    Buffer[I]:=Word(BufferL[I] SHR 16);
    For x:=0 to 63999 do mem[Buffer[I]:x]:=0;
  End;

  Buffer[4]:=$A000;
End;


Procedure ShutdownBuffers;
Var I: Byte;
Begin
  For I:=1 to 3 do Global_DOS_Free(BufferSel[I]);
End;


Procedure LoadGRPage(JmenoSouboru:string;Pozice:LongInt);
Var I: Word;
    WritedByte: Byte;
Begin
  Assign(F,JmenoSouboru);
  Reset(F,1);
  Seek(F,Pozice);
  BlockRead(F,RLEdelka,2);             {nacist delku}
  For I:=1 to RLEDelka do
  Begin
    BlockRead(F,WritedByte,1);
    RLEKompressed[1].DataB[I-1]:=WritedByte;
  End;
  RLEDekompress(1);                    {RLEkompressed => RLE}
  MovArraysTo3;                        {RLE => arrays}
  Rozkodovat;
  Close(F);
End;


Procedure LoadBmpFile(JmenoSouboru: string; pozice: LongInt; StartColor: Byte);
Var
  I,N: LongInt;
  Pixel1: Byte;
  Pixel2: Byte;
Begin
  Assign(F,JmenoSouboru);
  Reset(F,1);
  Seek(F,pozice);

  {Header}
  BlockRead(F,BMP.Header.Id,2);
  BlockRead(F,BMP.Header.Velikost,4);
  BlockRead(F,BMP.Header.Reserved,4);
  BlockRead(F,BMP.Header.DataOffset,4);
  BlockRead(F,BMP.Header.HeaderSize,4);
  BlockRead(F,BMP.Header.RozsahX,4);
  BlockRead(F,BMP.Header.RozsahY,4);
  BlockRead(F,BMP.Header.BitPlanes,2);
  BlockRead(F,BMP.Header.BPP,2);
  BlockRead(F,BMP.Header.Komprese,4);
  BlockRead(F,BMP.Header.ImageSize,4);
  BlockRead(F,BMP.Header.HorizontalRes,4);
  BlockRead(F,BMP.Header.VerticalRes,4);
  BlockRead(F,BMP.Header.Colors,4);
  BlockRead(F,BMP.Header.ImportantColors,4);

  {Palette}
  For I:=0 to 15 do
  Begin
    BlockRead(F,BMP.Palette[I].B,1);
    BlockRead(F,BMP.Palette[I].G,1);
    BlockRead(F,BMP.Palette[I].R,1);
    BlockRead(F,BMP.Palette[I].Reserved,1);
    BMP.Palette[I].B:=BMP.Palette[I].B DIV 4;
    BMP.Palette[I].G:=BMP.Palette[I].G DIV 4;
    BMP.Palette[I].R:=BMP.Palette[I].R DIV 4;
    SetPal(StartColor+I,BMP.Palette[I].R,BMP.Palette[I].G,BMP.Palette[I].B);
  End;

  {Data}
  N:=0;
  For I:=0 to (BMP.Header.ImageSize-1) do
  Begin
    BlockRead(F,BMP.DataByte,1);
    Pixel1:=(BMP.DataByte SHR 4);
    Pixel2:=(BMP.DataByte AND 15);
    Buffer0[N]:=StartColor+Pixel1;
    Buffer0[N+1]:=StartColor+Pixel2;
    Inc(N,2);
  End;

  Close(F);
End;


Procedure LoadBlok(x1,y1,x2,y2,x3,y3,BufferTo: Word);
Var Xa,Ya,x,y,Offset1,Offset2: Word;
Begin
  Xa:=x1; Ya:=y1;
  For y:=y2 to y3 do
  Begin
    For x:=x2 to x3 do
    Begin
      Offset1:=Ya*320+Xa; Offset2:=y*160+x;
      mem[BufferTo:Offset1]:=Buffer0[Offset2];
      inc(Xa);
    End;
    Xa:=x1; Inc(Ya);
  End;
End;


Procedure LoadBlokM(x1,y1,x2,y2,x3,y3,BufferTo: Word);
Var Xa,Ya,x,y,Offset1,Offset2: Word;
Begin
  Xa:=x1; Ya:=y1;
  For y:=y2 to y3 do
  Begin
    For x:=x3 downto x2 do
    Begin
      Offset1:=Ya*320+Xa; Offset2:=y*160+x;
      mem[BufferTo:Offset1]:=Buffer0[Offset2];
      inc(Xa);
    End;
    Xa:=x1; Inc(Ya);
  End;
End;


Procedure LoadSprite(x1,y1,x2,y2,x3,y3,BufferTo: Word);
Var Xa,Ya,x,y,Offset1,Offset2: Word;
Begin
  Xa:=x1; Ya:=y1;
  For y:=y2 to y3 do
  Begin
    For x:=x2 to x3 do
    Begin
      Offset1:=Ya*320+Xa; Offset2:=y*160+x;
      If Buffer0[Offset2]>0 then
      mem[BufferTo:Offset1]:=Buffer0[Offset2];
      inc(Xa);
    End;
    Xa:=x1; Inc(Ya);
  End;
End;


Procedure LoadSpriteM(x1,y1,x2,y2,x3,y3,BufferTo: Word);
Var Xa,Ya,x,y,Offset1,Offset2: Word;
Begin
  Xa:=x1; Ya:=y1;
  For y:=y2 to y3 do
  Begin
    For x:=x3 downto x2 do
    Begin
      Offset1:=Ya*320+Xa; Offset2:=y*160+x;
      If Buffer0[Offset2]>0 then
      mem[BufferTo:Offset1]:=Buffer0[Offset2];
      inc(Xa);
    End;
    Xa:=x1; Inc(Ya);
  End;
End;


Procedure LoadBitMap(X,Y: Word; BufferTo: Word);
Var xa,ya: Word;
    Offset1: Word;
    Offset2: Word;
Begin
  Offset2:=0;
  For ya:=(BMP.Header.RozsahY-1) downto 0 do
  For xa:=0 to (BMP.Header.RozsahX-1) do
  Begin
    Offset1:=((Y+ya)*320+(X+xa));
    mem[BufferTo:Offset1]:=Buffer0[Offset2];
    Inc(Offset2);
  End;
End;


Procedure LoadBitMapM(X,Y: Word; BufferTo: Word);
Var xa,ya: Word;
    Offset1: Word;
    Offset2: Word;
Begin
  Offset2:=0;
  For ya:=(BMP.Header.RozsahY-1) downto 0 do
  For xa:=(BMP.Header.RozsahX-1) downto 0 do
  Begin
    Offset1:=((Y+ya)*320+(X+xa));
    mem[BufferTo:Offset1]:=Buffer0[Offset2];
    Inc(Offset2);
  End;
End;


Procedure WritePixel(X:Word;Y,Color:Byte;Buffer:Word);
Begin
  mem[Buffer:Y*320+X]:=Color;
End;


Procedure Blok(x1,y1,x2,y2,Color,Buffer:Word);
Var Off,X,Y,delka,del,vyska,zbytek: Word;
    pocet: Byte;
    ColorL: LongInt;
Begin
  delka:=x2-x1+1;
  vyska:=y2-y1+1;
  pocet:=delka SHR 2;
  zbytek:=delka-(pocet SHL 2);
  del:=delka-zbytek;

  ColorL:=Color;
  ColorL:=ColorL SHL 8;
  Inc(ColorL,Color);
  ColorL:=ColorL SHL 8;
  Inc(ColorL,Color);
  ColorL:=ColorL SHL 8;
  Inc(ColorL,Color);

  If delka<4
  then Begin
         If zbytek>0 then
         Begin
           Off:=y1*320+x2-zbytek+1;
           For Y:=0 to vyska-1 do
           Begin
             For X:=0 to zbytek-1 do
             Begin
               mem[Buffer:Off]:=Color;
               Inc(Off);
             End;
             Dec(Off,zbytek);
             Inc(Off,320);
           End;
         End;
       End
  else Begin
         Off:=y1*320+x1;
         For Y:=0 to vyska-1 do
         Begin
           For X:=0 to pocet-1 do
           Begin
             memL[Buffer:Off]:=ColorL;
             Inc(Off,4);
           End;
           Dec(Off,del);
           Inc(Off,320);
         End;

         If zbytek>0 then
         Begin
           Off:=y1*320+x2-zbytek+1;
           For Y:=0 to vyska-1 do
           Begin
             For X:=0 to zbytek-1 do
             Begin
               mem[Buffer:Off]:=Color;
               Inc(Off);
             End;
             Dec(Off,zbytek);
             Inc(Off,320);
           End;
         End;
       End;
End;


Procedure Ramecek(X1,Y1,X2,Y2:Word;Color:Byte;Buffer:Word);
Var Off,X,Y,delka,del,vyska,zbytek: Word;
    pocet: Byte;
    ColorL: LongInt;
Begin
  delka:=X2-X1+1;
  vyska:=Y2-Y1+1;
  pocet:=delka SHR 2;
  zbytek:=delka-(pocet SHL 2);
  del:=delka-zbytek;

  ColorL:=Color;
  ColorL:=ColorL SHL 8;
  Inc(ColorL,Color);
  ColorL:=ColorL SHL 8;
  Inc(ColorL,Color);
  ColorL:=ColorL SHL 8;
  Inc(ColorL,Color);

  If delka<4
  then Begin
         If zbytek>0 then
         Begin
           Off:=Y1*320+X1;
           For Y:=0 to vyska-1 do
           Begin
             mem[Buffer:Off]:=Color;
             Inc(Off,320);
           End;
           Off:=Y1*320+X1;
           For X:=0 to zbytek-1 do
           Begin
             mem[Buffer:Off]:=Color;
             Inc(Off);
           End;
           Off:=Y2*320+X1;
           For X:=0 to zbytek-1 do
           Begin
             mem[Buffer:Off]:=Color;
             Inc(Off);
           End;
           Off:=Y1*320+X2;
           For Y:=0 to vyska-1 do
           Begin
             mem[Buffer:Off]:=Color;
             Inc(Off,320);
           End;
         End;
       End
  else Begin
         Off:=Y1*320+X1;
         For Y:=0 to vyska-1 do
         Begin
           mem[Buffer:Off]:=Color;
           Inc(Off,320);
         End;
         Off:=Y1*320+X1;
         For X:=0 to pocet-1 do
         Begin
           memL[Buffer:Off]:=ColorL;
           Inc(Off,4);
         End;
         Off:=Y2*320+X1;
         For X:=0 to pocet-1 do
         Begin
           memL[Buffer:Off]:=ColorL;
           Inc(Off,4);
         End;
         Off:=Y1*320+X2;
         For Y:=0 to vyska-1 do
         Begin
           mem[Buffer:Off]:=Color;
           Inc(Off,320);
         End;
         If zbytek>0 then
         Begin
           Off:=Y1*320+X2-zbytek;
           For X:=0 to zbytek-1 do
           Begin
             mem[Buffer:Off]:=Color;
             Inc(Off);
           End;
           Off:=Y2*320+X2-zbytek;
           For X:=0 to zbytek-1 do
           Begin
             mem[Buffer:Off]:=Color;
             Inc(Off);
           End;
         End;
       End;
End;


Procedure WriteBlok(x1,y1,x2,y2,x3,y3,BufferFrom,BufferTo: Word);
Var Off1,Off2,X,Y,delka,del,vyska,zbytek: Word;
    pocet: Byte;
Begin
  delka:=x3-x2+1;
  vyska:=y3-y2+1;
  pocet:=delka SHR 2;
  zbytek:=delka-(pocet SHL 2);
  del:=delka-zbytek;

  If delka<4
  then Begin
         If zbytek>0 then
         Begin
           Off1:=y1*320+x1+del;
           Off2:=y2*320+x2+del;
           For Y:=0 to vyska-1 do
           Begin
             For X:=0 to zbytek-1 do
             Begin
               mem[BufferTo:Off1]:=mem[BufferFrom:Off2];
               Inc(Off1);
               Inc(Off2);
             End;
             Dec(Off1,zbytek);
             Inc(Off1,320);
             Dec(Off2,zbytek);
             Inc(Off2,320);
           End;
         End;
       End
  else Begin
         Off1:=y1*320+x1;
         Off2:=y2*320+x2;
         For Y:=0 to vyska-1 do
         Begin
           For X:=0 to pocet-1 do
           Begin
             memL[BufferTo:Off1]:=memL[BufferFrom:Off2];
             Inc(Off1,4);
             Inc(Off2,4);
           End;
           Dec(Off1,del);
           Inc(Off1,320);
           Dec(Off2,del);
           Inc(Off2,320);
         End;

         If zbytek>0 then
         Begin
           Off1:=y1*320+x1+del;
           Off2:=y2*320+x2+del;
           For Y:=0 to vyska-1 do
           Begin
             For X:=0 to zbytek-1 do
             Begin
               mem[BufferTo:Off1]:=mem[BufferFrom:Off2];
               Inc(Off1);
               Inc(Off2);
             End;
             Dec(Off1,zbytek);
             Inc(Off1,320);
             Dec(Off2,zbytek);
             Inc(Off2,320);
           End;
         End;
       End;
End;


Procedure WriteSprite(x1,y1,x2,y2,x3,y3,BufferFrom,BufferTo: Word);
Var Off1,Off2,X,Y,delka,del,vyska,zbytek: Word;
    pocet,I: Byte;
Begin
  delka:=x3-x2+1;
  vyska:=y3-y2+1;
  pocet:=delka SHR 2;
  zbytek:=delka-(pocet SHL 2);
  del:=delka-zbytek;

  If delka<4
  then Begin
         If zbytek>0 then
         Begin
           Off1:=y1*320+x1+del;
           Off2:=y2*320+x2+del;
           For Y:=0 to vyska-1 do
           Begin
             For X:=0 to zbytek-1 do
             Begin
               If mem[BufferFrom:Off2]>0 then
               mem[BufferTo:Off1]:=mem[BufferFrom:Off2];
               Inc(Off1);
               Inc(Off2);
             End;
             Dec(Off1,zbytek);
             Inc(Off1,320);
             Dec(Off2,zbytek);
             Inc(Off2,320);
           End;
         End;
       End
  else Begin
         Off1:=y1*320+x1;
         Off2:=y2*320+x2;
         For Y:=0 to vyska-1 do
         Begin
           For X:=0 to pocet-1 do
           Begin
             If ((mem[BufferFrom:Off2]>0) and
                 (mem[BufferFrom:Off2+1]>0) and
                 (mem[BufferFrom:Off2+2]>0) and
                 (mem[BufferFrom:Off2+3]>0)) then
             Begin
               memL[BufferTo:Off1]:=memL[BufferFrom:Off2];
               Inc(Off1,4);
               Inc(Off2,4);
             End else
             Begin
               For I:=0 to 3 do
               Begin
                 If mem[BufferFrom:Off2]>0 then
                 mem[BufferTo:Off1]:=mem[BufferFrom:Off2];
                 Inc(Off1);
                 Inc(Off2);
               End;
             End;
           End;
           Dec(Off1,del);
           Inc(Off1,320);
           Dec(Off2,del);
           Inc(Off2,320);
         End;

         If zbytek>0 then
         Begin
           Off1:=y1*320+x1+del;
           Off2:=y2*320+x2+del;
           For Y:=0 to vyska-1 do
           Begin
             For X:=0 to zbytek-1 do
             Begin
               If mem[BufferFrom:Off2]>0 then
               mem[BufferTo:Off1]:=mem[BufferFrom:Off2];
               Inc(Off1);
               Inc(Off2);
             End;
             Dec(Off1,zbytek);
             Inc(Off1,320);
             Dec(Off2,zbytek);
             Inc(Off2,320);
           End;
         End;
       End;
End;


Procedure FlipPage(BufferFrom,BufferTo: Word);
Var A,I: Word;
Begin
  A:=0;
  For I:=0 to 15999 do
  Begin
    memL[BufferTo:A]:=memL[BufferFrom:A];
    Inc(A,4);
  End;
End;


Procedure ClearPage(Buffer:Word);
Var A,I: Word;
Begin
  A:=0;
  For I:=0 to 15999 do
  Begin
    memL[Buffer:A]:=0;
    Inc(A,4);
  End;
End;


{SECTION TEXTER XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Procedure InitTexter(Barva:Byte);
Var Offset,I,A: Word;
Begin
  TexterColor:=Barva;
  For I:=0 to 204 do
  Begin
    Dec2Bin(Znaky[I]);
    For A:=7 downto 0 do
    If b[A]=1 then BufferC[205*(7-A)+I]:=TexterColor;
  End;

  For I:=0 to 49 do
  Begin
    Dec2Bin(Cifry[I]);
    For A:=7 downto 0 do
    If b[A]=1 then BufferC1[50*(7-A)+I]:=TexterColor;
  End;

  For I:=0 to 39 do
  Begin
    Dec2Bin(SmallCifry[I]);
    For A:=7 downto 0 do
    If b[A]=1 then BufferC2[40*(7-A)+I]:=TexterColor;
  End;

  For I:=0 to 131 do
  Begin
    Dec2Bin(SmallZnaky[I]);
    For A:=7 downto 0 do
    If b[A]=1 then BufferC3[132*(7-A)+I]:=TexterColor;
  End;
End;


Procedure ShutdownTexter;
Begin
End;


Procedure ChangeTexterColor(Barva:Byte);
Begin
  TexterColor:=Barva;
End;


Procedure WriteTexterSprite1(x1,y1,x2,y2,x3,y3,BufferTo:Word);
Var Off1,Off2,X,Y,delka,vyska: Word;
Begin
  delka:=x3-x2+1;
  vyska:=y3-y2+1;

  Off1:=y1*320+x1;
  Off2:=y2*205+x2;
  For Y:=0 to vyska-1 do
  Begin
    For X:=0 to delka-1 do
    Begin
      If BufferC[Off2]>0 then
      mem[BufferTo:Off1]:=TexterColor;
      Inc(Off1);
      Inc(Off2);
    End;
    Dec(Off1,delka);
    Inc(Off1,320);
    Dec(Off2,delka);
    Inc(Off2,205);
  End;
End;


Procedure WriteTexterSprite2(x1,y1,x2,y2,x3,y3,BufferTo:Word);
Var Off1,Off2,X,Y,delka,vyska: Word;
Begin
  delka:=x3-x2+1;
  vyska:=y3-y2+1;

  Off1:=y1*320+x1;
  Off2:=y2*132+x2;
  For Y:=0 to vyska-1 do
  Begin
    For X:=0 to delka-1 do
    Begin
      If BufferC3[Off2]>0 then
      mem[BufferTo:Off1]:=TexterColor;
      Inc(Off1);
      Inc(Off2);
    End;
    Dec(Off1,delka);
    Inc(Off1,320);
    Dec(Off2,delka);
    Inc(Off2,132);
  End;
End;


Procedure WriteCifra(x,y:Word;Cislo:Byte;BufferTo:Word);
Var xa,ya,Offset:Word;
Begin
    For ya:=0 to 6 do
    Begin
      For xa:=0 to 4 do
      Begin
        Offset:=ya*50+((Cislo*5)+xa);
        If BufferC1[Offset]>0 then
         mem[BufferTo:(y+ya)*320+(x+xa)]:=TexterColor;
      End;
    End;
End;


Procedure WriteSmallCifra(x,y:Word;Cislo:Byte;BufferTo:Word);
Var xa,ya,Offset:Word;
Begin
    For ya:=0 to 4 do
    Begin
      For xa:=0 to 3 do
      Begin
        Offset:=ya*40+((Cislo*4)+xa);
        If BufferC2[Offset]>0 then
         mem[BufferTo:(y+ya)*320+(x+xa)]:=TexterColor;
      End;
    End;
End;


Procedure WriteZnak(X,Y:Word;Znak:Char;BufferTo:Word);
Var Ordinal: Byte;
Begin
  Ordinal:=Ord(Znak);

  If Ordinal in [48..57] then {znaky 0..9}
  WriteCifra(X,Y+1,Ordinal-48,BufferTo);

  If Ordinal in [65..90] then {znaky A..Z}
  WriteTexterSprite1(X,Y+1,(Ordinal-65)*5,0,(Ordinal-65)*5+4,6,BufferTo);

  Case Ordinal of {ostatni znaky}

{+} 43: WriteTexterSprite1(X,Y+1,130,0,134,6,BufferTo);
{-} 45: WriteTexterSprite1(X,Y+1,135,0,139,6,BufferTo);
{*} 42: WriteTexterSprite1(X,Y+1,140,0,142,6,BufferTo);
{/} 47: WriteTexterSprite1(X,Y,143,0,149,6,BufferTo);
{:} 58: WriteTexterSprite1(X,Y+1,150,0,154,6,BufferTo);
{.} 46: WriteTexterSprite1(X,Y+1,155,0,155,6,BufferTo);
{,} 44: WriteTexterSprite1(X,Y+2,160,0,160,6,BufferTo);
{=} 61: WriteTexterSprite1(X,Y+1,165,0,169,6,BufferTo);
{?} 63: WriteTexterSprite1(X,Y+1,170,0,174,6,BufferTo);
{%} 37: WriteTexterSprite1(X,Y+1,175,0,179,6,BufferTo);
{!} 33: WriteTexterSprite1(X,Y+1,180,0,180,6,BufferTo);
{(} 40: WriteTexterSprite1(X,Y+1,185,0,189,6,BufferTo);
{)} 41: WriteTexterSprite1(X,Y+1,190,0,194,6,BufferTo);
{>} 62: WriteTexterSprite1(X,Y+1,195,0,199,6,BufferTo);
{<} 60: WriteTexterSprite1(X,Y+1,200,0,204,6,BufferTo);

{a}  97: WriteTexterSprite2(X,Y,0,0,5,7,BufferTo);
{b}  98: WriteTexterSprite2(X,Y,6,0,10,7,BufferTo);
{c}  99: WriteTexterSprite2(X,Y,11,0,15,7,BufferTo);
{d} 100: WriteTexterSprite2(X,Y,16,0,20,7,BufferTo);
{e} 101: WriteTexterSprite2(X,Y,21,0,25,7,BufferTo);
{f} 102: WriteTexterSprite2(X,Y,26,0,30,7,BufferTo);
{g} 103: WriteTexterSprite2(X,Y+2,31,0,35,7,BufferTo);
{h} 104: WriteTexterSprite2(X,Y,36,0,40,7,BufferTo);
{i} 105: WriteTexterSprite2(X,Y,41,0,43,7,BufferTo);
{j} 106: WriteTexterSprite2(X,Y+2,44,0,46,7,BufferTo);
{k} 107: WriteTexterSprite2(X,Y,47,0,50,7,BufferTo);
{l} 108: WriteTexterSprite2(X,Y,51,0,53,7,BufferTo);
{m} 109: WriteTexterSprite2(X,Y,54,0,59,7,BufferTo);
{n} 110: WriteTexterSprite2(X,Y,60,0,64,7,BufferTo);
{o} 111: WriteTexterSprite2(X,Y,65,0,69,7,BufferTo);
{p} 112: WriteTexterSprite2(X,Y+2,70,0,75,7,BufferTo);
{q} 113: WriteTexterSprite2(X,Y+2,76,0,81,7,BufferTo);
{r} 114: WriteTexterSprite2(X,Y,82,0,86,7,BufferTo);
{s} 115: WriteTexterSprite2(X,Y,87,0,91,7,BufferTo);
{t} 116: WriteTexterSprite2(X,Y,92,0,95,7,BufferTo);
{u} 117: WriteTexterSprite2(X,Y,96,0,101,7,BufferTo);
{v} 118: WriteTexterSprite2(X,Y,102,0,106,7,BufferTo);
{w} 119: WriteTexterSprite2(X,Y,107,0,113,7,BufferTo);
{x} 120: WriteTexterSprite2(X,Y,114,0,118,7,BufferTo);
{y} 121: WriteTexterSprite2(X,Y+2,119,0,123,7,BufferTo);
{z} 122: WriteTexterSprite2(X,Y,124,0,128,7,BufferTo);
{} 160: Begin WriteTexterSprite2(X,Y,0,0,5,7,BufferTo); WriteTexterSprite2(X+3,Y,130,2,131,3,BufferTo); End;
{} 159: Begin WriteTexterSprite2(X,Y,11,0,15,7,BufferTo); WriteTexterSprite2(X+1,Y,129,2,131,3,BufferTo); End;
{+} 212: Begin WriteTexterSprite2(X,Y,16,0,20,7,BufferTo); WriteTexterSprite2(X+1,Y-2,129,2,131,3,BufferTo); End;
{} 130: Begin WriteTexterSprite2(X,Y,21,0,25,7,BufferTo); WriteTexterSprite2(X+2,Y,130,2,131,3,BufferTo); End;
{+} 216: Begin WriteTexterSprite2(X,Y,21,0,25,7,BufferTo); WriteTexterSprite2(X+1,Y,129,2,131,3,BufferTo); End;
{} 161: Begin WriteTexterSprite2(X,Y,41,0,43,7,BufferTo); WriteTexterSprite2(X+1,Y+1,130,2,131,3,BufferTo); End;
{s} 229: Begin WriteTexterSprite2(X,Y,60,0,64,7,BufferTo); WriteTexterSprite2(X+1,Y,129,2,131,3,BufferTo); End;
{} 162: Begin WriteTexterSprite2(X,Y,65,0,69,7,BufferTo); WriteTexterSprite2(X+2,Y,130,2,131,3,BufferTo); End;
{} 253: Begin WriteTexterSprite2(X,Y,82,0,86,7,BufferTo); WriteTexterSprite2(X+1,Y,129,2,131,3,BufferTo); End;
{t} 231: Begin WriteTexterSprite2(X,Y,87,0,91,7,BufferTo); WriteTexterSprite2(X+1,Y,129,2,131,3,BufferTo); End;
{} 156: Begin WriteTexterSprite2(X,Y,92,0,95,7,BufferTo); WriteTexterSprite2(X,Y-2,129,2,131,3,BufferTo); End;
{} 163: Begin WriteTexterSprite2(X,Y,96,0,101,7,BufferTo); WriteTexterSprite2(X+3,Y,130,2,131,3,BufferTo); End;
{} 133: Begin WriteTexterSprite2(X,Y,96,0,101,7,BufferTo); WriteTexterSprite2(X+1,Y-1,129,1,131,3,BufferTo); End;
{8} 236: Begin WriteTexterSprite2(X,Y+2,119,0,123,7,BufferTo); WriteTexterSprite2(X+2,Y,130,2,131,3,BufferTo); End;
{} 167: Begin WriteTexterSprite2(X,Y,124,0,128,7,BufferTo); WriteTexterSprite2(X+1,Y,129,2,131,3,BufferTo); End;

{} 181: Begin WriteTexterSprite1(X,Y+1,0,0,4,6,BufferTo); WriteTexterSprite2(X+2,Y-2,130,2,131,3,BufferTo); End;
{} 172: Begin WriteTexterSprite1(X,Y+1,10,0,14,6,BufferTo); WriteTexterSprite2(X+1,Y-2,129,2,131,3,BufferTo); End;
{-} 210: Begin WriteTexterSprite1(X,Y+1,15,0,19,6,BufferTo); WriteTexterSprite2(X+1,Y-2,129,2,131,3,BufferTo); End;
{} 144: Begin WriteTexterSprite1(X,Y+1,20,0,24,6,BufferTo); WriteTexterSprite2(X+2,Y-2,130,2,131,3,BufferTo); End;
{+} 183: Begin WriteTexterSprite1(X,Y+1,20,0,24,6,BufferTo); WriteTexterSprite2(X+1,Y-2,129,2,131,3,BufferTo); End;
{+} 214: Begin WriteTexterSprite1(X,Y+1,40,0,44,6,BufferTo); WriteTexterSprite2(X+1,Y-2,130,2,131,3,BufferTo); End;
{+} 213: Begin WriteTexterSprite1(X,Y+1,65,0,69,6,BufferTo); WriteTexterSprite2(X+1,Y-2,129,2,131,3,BufferTo); End;
{a} 224: Begin WriteTexterSprite1(X,Y+1,70,0,74,6,BufferTo); WriteTexterSprite2(X+2,Y-2,130,2,131,3,BufferTo); End;
{n} 252: Begin WriteTexterSprite1(X,Y+1,85,0,89,6,BufferTo); WriteTexterSprite2(X+1,Y-2,129,2,131,3,BufferTo); End;
{} 230: Begin WriteTexterSprite1(X,Y+1,90,0,94,6,BufferTo); WriteTexterSprite2(X+1,Y-2,129,2,131,3,BufferTo); End;
{} 155: Begin WriteTexterSprite1(X,Y+1,95,0,99,6,BufferTo); WriteTexterSprite2(X+1,Y-2,129,2,131,3,BufferTo); End;
{T} 233: Begin WriteTexterSprite1(X,Y+1,100,0,104,6,BufferTo); WriteTexterSprite2(X+2,Y-2,130,2,131,3,BufferTo); End;
{} 222: Begin WriteTexterSprite1(X,Y+1,100,0,104,6,BufferTo); WriteTexterSprite2(X+1,Y-3,129,1,131,3,BufferTo); End;
{f} 237: Begin WriteTexterSprite1(X,Y+1,120,0,124,6,BufferTo); WriteTexterSprite2(X+2,Y-2,130,2,131,3,BufferTo); End;
{} 166: Begin WriteTexterSprite1(X,Y+1,125,0,129,6,BufferTo); WriteTexterSprite2(X+1,Y-2,129,2,131,3,BufferTo); End;
  End; {Case End}

End;


Procedure WriteText(X,Y:Word;retezec:string;BufferTo:Word);
Var I: Word;
    posuv:Byte;
    Ordinal: Byte;
Begin
  posuv:=6; {default}
  For I:=1 to Length(retezec) do
  Begin
    Ordinal:=Ord(retezec[I]);
    Case Ordinal of {znaky o jine delce nez 5 ... nastavit jiny posuv}
{+} 214: posuv:=4;
{I} 73: posuv:=4;
{*} 42: posuv:=4;
{/} 47: posuv:=8;
{a} 97: posuv:=7;
{i} 105: posuv:=4;
{j} 106: posuv:=4;
{k} 107: posuv:=5;
{l} 108: posuv:=4;
{m} 109: posuv:=7;
{p} 112: posuv:=7;
{q} 113: posuv:=7;
{t} 116: posuv:=5;
{u} 117: posuv:=7;
{w} 119: posuv:=8;
{} 160: posuv:=7;
{} 161: posuv:=4;
{} 163: posuv:=7;
{} 133: posuv:=7;
{} 156: posuv:=5;
    End; {Case End}
    WriteZnak(X,Y,retezec[I],BufferTo);
    Inc(X,posuv);
    posuv:=6; {default}
  End;
End;


Procedure WriteNumber(x,y:Word;Cislo:Longint;Small:Boolean;BufferTo:Word);
Var MZbytek,MRozdil,delitel: Longint;
    Zapisovat:Boolean;
    posuv,pocet:Byte;
Begin
  posuv:=0;
  Zapisovat:=False;
  delitel:=1000000;
  For pocet:=0 to 6 do
  Begin
    If delitel>0 then
    Begin
      MRozdil:=Cislo div delitel;
      MZbytek:=Cislo mod delitel;
    End else
    Begin
      MRozdil:=0;
      MZbytek:=0;
    End;
    If MRozdil>0 then Zapisovat:=True;
    If Zapisovat=True then
    If Small=False then
                     Begin
                       WriteCifra(x+posuv,y,MRozdil,BufferTo);
                       Inc(posuv,6);
                     End
                   else
                     Begin
                       WriteSmallCifra(x+posuv,y,MRozdil,BufferTo);
                       Inc(posuv,5);
                     End;
    Cislo:=MZbytek;
    If delitel>0 then delitel:=delitel div 10;
  End;
  If (Zapisovat=False) And (MRozdil=0) then
  If Small=False then WriteCifra(x+posuv,y,MRozdil,BufferTo)
                 else WriteSmallCifra(x+posuv,y,MRozdil,BufferTo);
End;


{SECTION MAP XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Procedure RLEDekompresMap;
Var
  WritedBA: Byte; {znak A}
  WritedBB: Byte; {je-li komprese tak stejny jako znak A}
  WritedBC: Byte; {pocet kolikrat tam je znak A }
  I,A,posun: Word;
Begin
  I:=0; posun:=0;
  While not (posun=Map.DelkaRLE) do
  Begin

    WritedBA:=Map.MapBufferRLE[posun];      {nacteme A}
    Inc(posun);
    If posun=Map.DelkaRLE then               {je-li konec zapsat a BREAK}
    Begin
      Map.MapBuffer[I]:=WritedBA;
      Break;
    End;

    WritedBB:=Map.MapBufferRLE[posun];      {nacteme B}
    Inc(posun);

    If posun=Map.DelkaRLE then          {je-li konec zapsat a BREAK}
    Begin
      Map.MapBuffer[I]:=WritedBA;
      Map.MapBuffer[I+1]:=WritedBB;
      Break;
    End;

    If WritedBA=WritedBB then  {jsou-li dva stejne tzn. nasleduje pocet}
    Begin
      WritedBC:=Map.MapBufferRLE[posun]; {muzeme nacist pocet}
      Inc(posun);
      For A:=1 to WritedBC do
      Begin
        Map.MapBuffer[I]:=WritedBA; {zapisujeme WritedBC krat}
        Inc(I);
      End;
    End else {jsou dva ruzne}
    Begin
      Map.MapBuffer[I]:=WritedBA;   {zapisme jeden a navrat nahoru}
      Inc(I);
      Dec(posun);         {posuneme index o jednu nazpet}
    End;

  End; {While End}
End;


Procedure LoadMapFile(soubor: string; pozice: Longint);
Var
  F: File;
  I: Word;
Begin
  Assign(F,soubor);
  Reset(F,1);
  Seek(F,pozice);
  BlockRead(F,Map.DelkaRLE,2);
  For I:=0 to Map.DelkaRLE do BlockRead(F,Map.MapBufferRLE[I],1);
  Close(F);
  RLEDekompresMap;
End;


Procedure SetMapByte(MapOffset:Word; bajt:Byte);
Begin
  Map.MapBuffer[MapOffset]:=bajt;
End;


Function GetMapByte(MapOffset: Word): Byte;
Begin
  GetMapByte:=Map.MapBuffer[MapOffset];
End;


{SECTION KEYBOARD XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure int9_handler; assembler; interrupt;
asm
  cli
  push  ds
  push  es
  push  fs
  push  gs
  pusha
  mov   ax, cs:[Backup1DS]
  mov   ds, ax
  mov   es, ax
  mov   ax, dosmemselector
  mov   fs, ax
  call  clickproc
  popa
  pop   gs
  pop   fs
  pop   es
  pop   ds
  sti
end;


procedure int9_dummy; begin end;


procedure Keyboard;
begin
  PressedKey:=InPortB($60);
  If PressedKey<128 then Key[PressedKey]:=True
                    else Key[PressedKey-128]:=False;
  OutPortB($20,$20);
end;


procedure Keyboard_dummy; begin end;


procedure InitKeyboard;
begin
  clickproc := @Keyboard;
  lock_data(clickproc, sizeof(clickproc));
  lock_data(dosmemselector, sizeof(dosmemselector));
  lock_data(Key, sizeof(Key));
  lock_data(PressedKey, sizeof(PressedKey));
  lock_code(@Keyboard, longint(@Keyboard_dummy) - longint(@Keyboard));
  lock_code(@int9_handler, longint(@int9_dummy)-longint(@int9_handler));
  newint9_handler.offset := @int9_handler;
  newint9_handler.segment := get_cs;
  get_pm_interrupt(kbdint, oldint9_handler);
  set_pm_interrupt(kbdint, newint9_handler);
end;


procedure ShutdownKeyboard;
begin
  set_pm_interrupt(kbdint, oldint9_handler);
  unlock_data(dosmemselector, sizeof(dosmemselector));
  unlock_data(clickproc, sizeof(clickproc));
  unlock_data(PressedKey, sizeof(PressedKey));
  unlock_data(Key, sizeof(Key));
  unlock_code(@Keyboard, longint(@Keyboard_dummy)-longint(@Keyboard));
  unlock_code(@int9_handler, longint(@int9_dummy)-longint(@int9_handler));
end;


{SECTION TIMER XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Procedure Wait(ms: Word);
Begin
  delaycounter:=0;
  waiting:=True;
  While delaycounter<ms*8 do Begin End;
  waiting:=False;
  delaycounter:=0;
End;


Procedure Sound(Hertz: Word); Assembler;
Asm
  MOV    BX,SP
  MOV    BX,&Hertz
  MOV    AX,34DDh
  MOV    DX,0012h
  CMP    DX,BX
  JNB    @J1
  DIV    BX
  MOV    BX,AX
  IN     AL,61h
  TEST   AL,03h
  JNZ    @J2
  OR     AL,03h
  OUT    61h,AL
  MOV    AL,-4Ah
  OUT    43h,AL
@J2:
  MOV    AL,BL
  OUT    42h,AL
  MOV    AL,BH
  OUT    42h,AL
@J1:
End;


Procedure SoundDummy; begin end;


Procedure Silence; Assembler;
Asm
  IN     AL,61h
  AND    AL,0FCh
  OUT    61h,AL
End;


Procedure SilenceDummy; begin end;


Procedure Stopky_Start;
Begin
  StopkyTics:=0;
  StopkyActive:=True;
End;


Procedure Stopky_Stop;
Begin
  StopkyActive:=False;
End;


Function Stopky_GetNumber: LongInt;
Begin
  Stopky_GetNumber:=StopkyTics;
End;


Procedure LoadSNDFile(Filename:String;Pozice:LongInt);
Var I: Word;
    ReadByte: Byte;
Begin
  Assign(F,Filename);
  Reset(F,1);
  Seek(F,Pozice);
  BlockRead(F,RLEdelka,2);             {nacist delku}
  For I:=1 to RLEdelka do
  Begin
    BlockRead(F,ReadByte,1);
    RLEKompressed[2].DataB[I-1]:=ReadByte;
  End;
  RLEDekompress(2);                    {RLEkompressed => RLE}
  MovArrayTo2;                         {RLE => SoundData a ZvukTab}
  Close(F);
End;


Procedure LoadRAWFile(filename:String;Pozice:LongInt;N:Byte); {do 32KB}
Var F: File;
    ReadByte: Byte;
    I: Word;
Begin
  Assign(F,filename);
  Reset(F,1);
  Seek(F,Pozice);
  BlockRead(F,Sample[N].Delka,4);
  For I:=0 to Sample[N].Delka-1 do
  Begin
    BlockRead(F,ReadByte,1);
    SampleData[N].Data[I]:=ReadByte;
  End;
  Close(F);
End;


Procedure PlaySound(Sample:Byte);
Begin
  PrehravatZvuk:=True;       {sdelime handleru int8 ze chceme prehravat}
  CisloZvuku:=Sample;        {predame ktery zvuk se ma hrat}
  PosuvZ:=0;                 {nastavime na zacatek zvuku}
End;


Procedure PlayRaw(Cislo:Byte);
Var
  I: Word;
Begin
  For I:=0 to Sample[Cislo].Delka-1 do SPBuffer[I]:=SampleData[Cislo].Data[I];
  Sample[Cislo].Pocitadlo:=0;
  PrehravanyZvuk:=Cislo;
  OffsetSpeakeru:=0;
  RawHraje:=True;
End;


Procedure StopPlay;
Begin
  RawHraje:=False;
  PrehravatZvuk:=False;
End;


Function FPS2s: Boolean;
Begin
  If fps_helper<100 then FPS2s:=False {false v prvni vterine}
                    else FPS2s:=True; {true ve druhe vterine}
End;


Procedure int1c_handler; assembler; interrupt;
asm
cli
push fs
push es
push ds
push ax
   mov  ax,cs:[Backup2DS]
   mov  ds,ax
   mov  es,ax
   mov  ax,dosmemselector
   mov  fs,ax
   call TimerProc
pop ax
pop ds
pop es
pop fs
sti
end;


Procedure HandlerDummy;begin end;


Procedure MujCasovacDummy;begin end;


Procedure MujCasovac;
begin
  {zpozdovac}
  If waiting=True then Inc(delaycounter); {je prave jedna milisekunda}

  {prehravani zvuku}
  If player=80 then If PrehravatZvuk=True then
  Begin
    If SoundData[ZvukTab[CisloZvuku*2]+PosuvZ]>0
    then Sound(SoundData[ZvukTab[CisloZvuku*2]+PosuvZ])
    else Sound(10);
    Inc(PosuvZ);
    If PosuvZ>ZvukTab[CisloZvuku*2+1] then {prehrali jsme celou delku zvuku}
    Begin
      PrehravatZvuk:=False;
      PosuvZ:=0;
      Silence;
    End
  End;

  {prehravani rawu}
  If RawHraje then
  Begin
    vzorek:=SPBuffer[OffsetSpeakeru];

    Asm
     mov al,vzorek
     shr al,6
     and al,2
     out 61h,al
     in al,40h
     xchg al,ah
     in al,40h
     xchg al,ah
     mov dx,ax
    End;

    Inc(Sample[PrehravanyZvuk].Pocitadlo);
    If Sample[PrehravanyZvuk].Pocitadlo=Sample[PrehravanyZvuk].Delka
    then RawHraje:=False;
    If OffsetSpeakeru<31999 then Inc(OffsetSpeakeru) else OffsetSpeakeru:=0;
  End;

  {helper pro vypocet fps kazde 2 sekundy}
  If player=80 then {je setina vteriny ?}
  Begin
    If fps_helper<200 then Inc(fps_helper) else fps_helper:=0;
  End;

  {If Player=80 then: je prave jedna setina vteriny}
  If player<80 then Inc(player)
               else player:=0;

  {stopky}
  If StopkyActive=True then
  Begin
    If stopky<7
    then Begin
           Inc(stopky);
         End
    else Begin
          stopky:=0;
          Inc(StopkyTics);
         End;
  End;

OutPortB($20,$20);
end;


Procedure InitTimer;
var i : Longint;
    counter:longint;
begin
  timerproc:=@MujCasovac;
  newint1c.offset := @int1c_handler;
  newint1c.segment := get_cs;

  lock_data(timerproc, sizeof(timerproc));
  lock_data(dosmemselector, sizeof(dosmemselector));

  lock_data(waiting, sizeof(waiting));
  lock_data(delaycounter, sizeof(delaycounter));
  lock_data(player, sizeof(player));
  lock_data(PrehravatZvuk, sizeof(PrehravatZvuk));
  lock_data(SoundData, sizeof(SoundData));
  lock_data(ZvukTab, sizeof(ZvukTab));
  lock_data(CisloZvuku, sizeof(CisloZvuku));
  lock_data(PosuvZ, sizeof(PosuvZ));
  lock_data(Sample,sizeof(Sample));
  lock_data(PrehravanyZvuk,sizeof(PrehravanyZvuk));
  lock_data(vzorek,sizeof(vzorek));
  lock_data(SPBuffer,sizeof(SPBuffer));
  lock_data(OffsetSpeakeru,sizeof(OffsetSpeakeru));
  lock_data(RawHraje,sizeof(RawHraje));
  lock_data(fps_helper, sizeof(fps_helper));
  lock_data(StopkyActive, sizeof(StopkyActive));
  lock_data(StopkyTics, sizeof(StopkyTics));

  lock_code(@Sound,longint(@SoundDummy) - longint(@Sound));
  lock_code(@Silence,longint(@SilenceDummy) - longint(@Silence));

  lock_code(@MujCasovac,longint(@MujCasovacDummy) - longint(@MujCasovac));
  lock_code(@int1c_handler,longint(@HandlerDummy)-longint(@int1c_handler));
  get_pm_interrupt(int1c, oldint1c);
  set_pm_interrupt(int1c, newint1c);

  counter:=$1234DD div 8000; {frekvence=8000}
  OutPortB($43,$34);
  OutPortB($40,counter mod 256);
  OutPortB($40,counter div 256);
end;


Procedure ShutdownTimer;
begin
  OutPortB($43,$34);
  OutPortB($40,0);
  OutPortB($40,0);

  unlock_data(waiting, sizeof(waiting));
  unlock_data(delaycounter, sizeof(delaycounter));
  unlock_data(player, sizeof(player));
  unlock_data(PrehravatZvuk, sizeof(PrehravatZvuk));
  unlock_data(SoundData, sizeof(SoundData));
  unlock_data(ZvukTab, sizeof(ZvukTab));
  unlock_data(CisloZvuku, sizeof(CisloZvuku));
  unlock_data(PosuvZ, sizeof(PosuvZ));
  unlock_data(Sample,sizeof(Sample));
  unlock_data(PrehravanyZvuk,sizeof(PrehravanyZvuk));
  unlock_data(vzorek,sizeof(vzorek));
  unlock_data(SPBuffer,sizeof(SPBuffer));
  unlock_data(OffsetSpeakeru,sizeof(OffsetSpeakeru));
  unlock_data(RawHraje,sizeof(RawHraje));
  unlock_data(fps_helper, sizeof(fps_helper));
  unlock_data(StopkyActive, sizeof(StopkyActive));
  unlock_data(StopkyTics, sizeof(StopkyTics));
  unlock_code(@Sound,longint(@SoundDummy) - longint(@Sound));
  unlock_code(@Silence,longint(@SilenceDummy) - longint(@Silence));

  unlock_data(timerproc, sizeof(timerproc));
  unlock_data(dosmemselector, sizeof(dosmemselector));
  unlock_code(@MujCasovac,longint(@MujCasovacDummy) - longint(@MujCasovac));
  unlock_code(@int1c_handler,longint(@HandlerDummy)-longint(@int1c_handler));
  set_pm_interrupt(int1c, oldint1c);
end;


{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Begin End.

{klavesy xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
{2}  1  {16} Q  {30} A  {45} X  {1}  Esc        {59} F1   {72} KeyPadUp
{3}  2  {17} W  {31} S  {46} C  {15} TAB        {60} F2   {80} KeyPadDown
{4}  3  {18} E  {32} D  {47} V  {28} Enter      {61} F3   {75} KeyPadleft
{5}  4  {19} R  {33} F  {48} B  {14} BackSpace  {62} F4   {77} KeyPadRight
{6}  5  {20} T  {34} G  {49} N  {57} Space      {63} F5
{7}  6  {21} Y  {35} H  {50} M                  {64} F6   {71} KeyPadHome
{8}  7  {22} U  {36} J          {12} Minus      {65} F7   {79} KeyPadEnd
{9}  8  {23} I  {37} K          {13} Plus       {66} F8   {73} KeyPadPgUp
{10} 9  {24} O  {38} L          {53} Lomitko    {67} F9   {81} KeyPadPgDn
{11} 0  {25} P  {44} Z          {55} Hvezdicka  {68} F10  {82} KeyPadIns
                                                {87} F11  {83} KeyPadDel
{26} HranataZavorka1    {58} CapsLock           {88} F12
{27} HranataZavorka2    {69} NumLock
{41} Semicolon          {70} ScrollLock      {29} LeftControl
{39} Strednik           {76} KeyPad5         {56} LeftAlt
{40} Uvozovka           {78} KeyPadPlus      {42} LeftShift
{51} Carka              {74} KeyPadMinus     {54} RightShift
{52} Tecka
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
