#pragma once

class CDIBSection // CDIBSection is a base class, not meant to be used at all.
{
        protected:
                RECT m_rect;
                HWND m_hwndParent;
                HDC m_hdc;
                HBITMAP m_hbm, m_oldhbm;

                struct
                {
                        BITMAPINFO bmi;
                        RGBQUAD more_bmiColors[256];
                        LPVOID data;
                } m_bitmap;

                virtual void m_Initialize(HWND hwnd, RECT *r)=0;
                virtual void m_DeInitialize();
                virtual void m_PreRender(HDC hdc) { };
        public:
                virtual void SetPalette(unsigned char *palette) { }
                void SetRect(RECT *r=NULL);
                void *GetBuffer() {  return m_bitmap.data; }
                HDC   GetHDC() { return m_hdc; }
                void Update();
                void Paint(HDC hdc);
                int GetWidth() { return (m_rect.right-m_rect.left); }
                int GetPitch() { return (m_rect.right-m_rect.left+3)&~3; }
                int GetHeight() { return m_rect.bottom-m_rect.top; }
};

class CDIBSection8 : public CDIBSection
{
        protected:
                unsigned char m_pal[768];
                HPALETTE m_hpal;
                virtual void m_SetupPalette();
                virtual void m_Initialize(HWND hwnd, RECT *r);
                virtual void m_DeInitialize();
                virtual void m_PreRender(HDC hdc);
        public:
                CDIBSection8(HWND hwnd=NULL,RECT *r=NULL,unsigned char *palette=NULL);
                ~CDIBSection8();
                virtual void SetPalette(unsigned char *palette);
};

class CDIBSection16 : public CDIBSection
{
        protected:
                HPALETTE m_hpal;
                virtual void m_SetupPalette();
                virtual void m_Initialize(HWND hwnd, RECT *r);
                virtual void m_DeInitialize();
                virtual void m_PreRender(HDC hdc);
        public:
                CDIBSection16(HWND hwnd=NULL,RECT *r=NULL);
                ~CDIBSection16();
};
